﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "Weapon/LMRevolver.h"

#include "Player/LMBulletInfo.h"
#include "Player/LMPlayer.h"


ALMRevolver::ALMRevolver()
{
	PrimaryActorTick.bCanEverTick = true;
}

void ALMRevolver::PrimaryFire()
{
	if (!Player)
		return;
	
	State = EWeaponState::EWS_Firing;

	if (ClipAmmo <= 0)
	{
		if (!Reload())
		{
			PlaySound(DryFireSound, true);
			GetWorldTimerManager().SetTimer(FireTimer, this, &ALMRevolver::AllowRefire, RefireDelay / 2);
		}
		return;
	}

	
	PlaySound(FireSound, true);
	PlayAnimation(PrimaryFireAnimation);

	const FVector Origin = Player->GetWeaponFiringOrigin();
	const FVector Direction = Player->GetAimVector();

	ClipAmmo--;

	FLMBulletInfo ShotInfo = FLMBulletInfo(1, Origin, Direction, WeaponSpread, MaxDistance, DamageFalloff, AmmoType, Damage);

	Player->FireBullets(ShotInfo);
	GetWorldTimerManager().SetTimer(FireTimer, this, &ALMRevolver::AllowRefire, RefireDelay);
}

